package com.sun.xml.internal.ws.wsdl;

import com.sun.xml.internal.ws.api.message.Packet;
import java.util.Iterator;
import com.sun.xml.internal.ws.model.JavaMethodImpl;
import com.sun.xml.internal.ws.model.AbstractSEIModelImpl;
import com.sun.xml.internal.ws.api.model.wsdl.WSDLBoundOperation;
import java.util.HashMap;
import com.sun.istack.internal.Nullable;
import com.sun.xml.internal.ws.api.model.SEIModel;
import com.sun.xml.internal.ws.api.WSBinding;
import com.sun.xml.internal.ws.api.model.wsdl.WSDLPort;
import com.sun.xml.internal.ws.api.model.WSDLOperationMapping;
import java.util.Map;

final class SOAPActionBasedOperationFinder extends WSDLOperationFinder
{
    private final Map<String, WSDLOperationMapping> methodHandlers;
    
    public SOAPActionBasedOperationFinder(WSDLPort wsdlModel, WSBinding binding, @Nullable SEIModel seiModel) {
        super(wsdlModel, binding, seiModel);
        this.methodHandlers = new HashMap();
        Map<String, Integer> unique = new HashMap();
        if (seiModel != null) {
            for (JavaMethodImpl m : ((AbstractSEIModelImpl)seiModel).getJavaMethods()) {
                String soapAction = m.getSOAPAction();
                Integer count = (Integer)unique.get(soapAction);
                if (count == null) {
                    unique.put(soapAction, Integer.valueOf(1));
                }
                else {
                    unique.put(soapAction, count = Integer.valueOf((int)count + 1));
                }
            }
            for (JavaMethodImpl m : ((AbstractSEIModelImpl)seiModel).getJavaMethods()) {
                String soapAction = m.getSOAPAction();
                if ((int)unique.get(soapAction) == 1) {
                    this.methodHandlers.put(34 + soapAction + 34, this.wsdlOperationMapping(m));
                }
                else {
                    continue;
                }
            }
        }
        else {
            for (WSDLBoundOperation wsdlOp : wsdlModel.getBinding().getBindingOperations()) {
                this.methodHandlers.put(wsdlOp.getSOAPAction(), this.wsdlOperationMapping(wsdlOp));
            }
        }
    }
    
    @Override
    public WSDLOperationMapping getWSDLOperationMapping(Packet request) throws DispatchException {
        return (request.soapAction == null) ? null : ((WSDLOperationMapping)this.methodHandlers.get(request.soapAction));
    }
}
